import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 22.03.2017
  * @author
  */  

public class TaxiGUI extends JFrame {
  // Anfang Attribute
  private JButton btnAufahren = new JButton();
  private JButton btnAnkommen = new JButton();
  private JButton btnExitPrgm = new JButton();
  private JNumberField nmrSpecial = new JNumberField();
  private JButton btnSpecial = new JButton();
  private JLabel lblSpec = new JLabel();

  private Taxi tax1 = new Taxi("Peter","SN-PE-201",true,false);
  private Taxi tax2 = new Taxi("Hans","SN-HA-137",false,false);
  private Taxi tax3 = new Taxi("Laurence","SN-LA-108",false, true);
  private Taxi tax4 = new Taxi("Tyler","SN-TY-687",false, false);
  private Taxi tax5 = new Taxi("Connor","SN-CN-357",true, true);
  private Taxi tax6 = new Taxi("Troye","SN-TR-913",true, true);
  private Taxi tax7 = new Taxi("Erik","SN-ER-713",false, false);

  private LinkedList taxiList = new LinkedList();
  private LinkedList taxiListNichtDa = new LinkedList();
  private JLabel lblInfoH = new JLabel();
  private JTextField txtSpecOutput = new JTextField();
  private JLabel lblOuputSpec = new JLabel();
  private JTextField txtOutput = new JTextField();
  private JLabel lblOutput = new JLabel();
  // Ende Attribute
  
  public TaxiGUI(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 460; 
    int frameHeight = 300;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    taxiList.add(tax7);
    taxiList.add(tax2);
    taxiList.add(tax3);
    taxiList.add(tax4);
    taxiList.add(tax5);
    taxiList.add(tax6);
    taxiListNichtDa.add(tax1);
    ausgabeTaxis();
    btnAufahren.setBounds(8, 224, 123, 25);
    btnAufahren.setText("Abfahren");
    btnAufahren.setMargin(new Insets(2, 2, 2, 2));
    btnAufahren.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnAufahren_ActionPerformed(evt);
      }
    });
    cp.add(btnAufahren);
    btnAnkommen.setBounds(168, 224, 123, 25);
    btnAnkommen.setText("Ankommen");
    btnAnkommen.setMargin(new Insets(2, 2, 2, 2));
    btnAnkommen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnAnkommen_ActionPerformed(evt);
      }
    });
    cp.add(btnAnkommen);
    btnExitPrgm.setBounds(320, 224, 123, 25);
    btnExitPrgm.setText("Schließen");
    btnExitPrgm.setMargin(new Insets(2, 2, 2, 2));
    btnExitPrgm.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnExitPrgm_ActionPerformed(evt);
      }
    });
    cp.add(btnExitPrgm);
    nmrSpecial.setBounds(112, 128, 59, 28);
    nmrSpecial.setText("");
    cp.add(nmrSpecial);
    btnSpecial.setBounds(184, 128, 75, 25);
    btnSpecial.setText("Infos");
    btnSpecial.setMargin(new Insets(2, 2, 2, 2));
    btnSpecial.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        btnSpecial_ActionPerformed(evt);
      }
    });
    cp.add(btnSpecial);
    lblSpec.setBounds(16, 128, 94, 28);
    lblSpec.setText("Eingabe");
    cp.add(lblSpec);
    lblInfoH.setBounds(8, 96, 110, 20);
    lblInfoH.setText("-Infos-");
    cp.add(lblInfoH);
    txtSpecOutput.setBounds(112, 176, 326, 20);
    cp.add(txtSpecOutput);
    lblOuputSpec.setBounds(16, 176, 94, 20);
    lblOuputSpec.setText("Ausgabe");
    cp.add(lblOuputSpec);
    txtOutput.setBounds(112, 24, 318, 20);
    cp.add(txtOutput);
    lblOutput.setBounds(8, 24, 97, 20);
    lblOutput.setText("Ausgabe Taxistand");
    lblOutput.setToolTipText("Ausgabe Taxistand");
    cp.add(lblOutput);
    // Ende Komponenten
    
    setVisible(true);
  } // end of public TaxiGUI
  
  // Anfang Methoden
  
  public static void main(String[] args) {
    new TaxiGUI("Taxistand");
  } // end of main
  
  public void btnAufahren_ActionPerformed(ActionEvent evt) {
    if(taxiList.size()>=1){
      taxiListNichtDa.add(taxiList.get(0));
      taxiList.remove(0);
      ausgabeTaxis();
    }
  } // end of btnAufahren_ActionPerformed
  
  public void btnAnkommen_ActionPerformed(ActionEvent evt) {
    if(taxiList.size()<6){
      taxiList.add(taxiListNichtDa.get(0));
      taxiListNichtDa.remove(0);
      ausgabeTaxis();
    }
  } // end of btnAnkommen_ActionPerformed
  
  public void btnExitPrgm_ActionPerformed(ActionEvent evt) {
    System.exit(0);
  } // end of btnExitPrgm_ActionPerformed
  
  public void btnSpecial_ActionPerformed(ActionEvent evt) {
    int specInt = nmrSpecial.getInt();
    if(specInt>=0 && specInt < taxiList.size())
    getInfos(specInt);
  } // end of btnSpecial_ActionPerformed
  
  public void ausgabeTaxis(){
    String ausgabe = "";
    for(int n = 0; n < taxiList.size(); n++){
      Taxi t = (Taxi)taxiList.get(n);
      ausgabe = ausgabe + t.getFahrername() + " | ";
    }
    txtOutput.setText(ausgabe);
  }
  
  public boolean prufeNummernschild(String nmrSchild){
    for(int n = 0; n < taxiList.size(); n++){
      Taxi t = (Taxi)taxiList.get(n);
      if(t.getKennzeichen() == nmrSchild){
        return true;
      }
    }
    return false;
  }
  
  public void getInfos(int i){
    Taxi t = (Taxi)taxiList.get(i);
    String infoAusgabe = t.getFahrername() + ", " + t.getKennzeichen();
    if(t.getHund()){
      infoAusgabe = infoAusgabe + ", Hunde erlaubt";
    }else{
      infoAusgabe = infoAusgabe + ", Hunde nicht erlaubt";
    }
    if(t.getBehindertengerecht()){
      infoAusgabe = infoAusgabe + ", Behindertengerecht";
    }else{
      infoAusgabe = infoAusgabe + ", nicht Behindertengerecht";
    }
    txtSpecOutput.setText(infoAusgabe);
  }
  
  // Ende Methoden
} // end of class TaxiGUI
